unit Laskuri;

interface

uses
  SysUtils, Classes, Controls, StdCtrls, Graphics;

type
	  TLaskuri = class;

	  TLaskuriEvent = procedure (sender:TLaskuri; diff:integer) of object;

(*
  TLaskuri = class(TCustomLabel)
  private
    FCount: integer;
    procedure SetCount(const Value: integer);
    function GetCount:integer;
  protected
  public
    constructor Create(AOwner:TComponent); override;
    function Inc(i:integer) : integer;     virtual;
  published
    property Count:integer read FCount write SetCount default 0;
    property Align;
    property Alignment;
    property Anchors;
    property AutoSize;
    property BiDiMode;
    property Color nodefault;
    property Constraints;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property FocusControl;
    property Font;
    property ParentBiDiMode;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowAccelChar;
    property ShowHint;
    property Transparent;
    property Layout;
    property Visible;
    property WordWrap;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnMouseEnter;
    property OnMouseLeave;
    property OnStartDock;
    property OnStartDrag;
  end;
*)

  TLaskuri = class(TLabel)
  private
    FCount: integer;
    FOnChange: TLaskuriEvent;
    procedure SetCount(const Value: integer);
    function GetCount:integer;
    function GetCaption: string;
    procedure SetCaption(const Value: string);
  protected
  public
    constructor Create(AOwner:TComponent); override;
    function Inc(i:integer) : integer;     virtual;
  published
    property Count:integer read FCount write SetCount default 0;
    property Caption:string read GetCaption write SetCaption stored false;
    property Alignment        default taRightJustify;
    property AutoSize         default False;
    property Color            default clAqua;
    property ParentColor      default false;
    property OnChange : TLaskuriEvent read FOnChange write FOnChange;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('GKOC', [TLaskuri]);
end;


{ TLaskuri }

constructor TLaskuri.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Alignment := taRightJustify;  // default-arvot
  Color := clAqua;
  ParentColor := False;
  Font.Height := -32;
  Font.Style := [fsBold];
  AutoSize := False;
  Count := 0;
//  FOnChange := nil;
end;

function TLaskuri.GetCount: integer;
begin
  Result := FCount;
end;

function TLaskuri.Inc(i: integer): integer;
begin
  Count := Count + i;
  Result := Count;
end;


function TLaskuri.GetCaption: string;
begin
  Result := Trim(inherited Caption); { Varo rekursiota!!! }
end;

procedure TLaskuri.SetCaption(const Value: string);
begin
  Count := StrToIntDef(Trim(Value),0);
end;

procedure TLaskuri.SetCount(const Value: integer);
var diff : integer;
begin
  if (Value = FCount) then Exit;
  diff := Value - Count;
  FCount := Value;
  inherited Caption := IntToStr(Count);

  if ( Assigned(OnChange) ) then OnChange(self,diff);

  //  if ( OnChange <> nil ) then OnChange(self);
end;

end.
